
/* 
 * RECView.h -- Interface file for the RECView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, or even that it has a use at all.
 *
 */

#import <appkit/appkit.h>

@interface RECView:View {

	id		tiDat;

	id		inCol0;
	id		inCol1;

	id		theWellBox;

	id		browser;

	id		exsli;
	id		wysli;
	id		bigView;
	id		bigWindow;
	id		infoPanel;
	id		parPanel;

	id		comment;

	id		lilView;
	id		lilWindow;
	id		execWin;
	id		execLine;
	id		value;

	id		keyWindow;
	id		menuCopy;
	id		menuPrint;

	id		crossCursor;
	float		radius;

	char		*filename;
	char		**filenames;

        id              windows;
        id 		externalRECBox;
        id 		internalRECBox;
    	id 		theBigBox;
	id		theLilBox;
	id		xtrnWin;

}

- ascii:sender;
- recMatrix:sender;

- rexsli:sender;
- rwysli:sender;

- run:sender;
- recompile:sender;
- gho:sender;
- setOption:sender;
- windowWillClose:sender;
- loadRECPanel:sender;
- loadInternal:sender;
- loadExternal:sender;
- loadLowerPaneltwo:thisRuleBox;
- nhul:sender;
- browserDoubleClick:sender;

- smartPrintBigWin:sender;
- openBigWin:sender;

- open:sender;
- setFilename:(const char *)aFilename;
- save:sender;
- saveAs:sender;

- copyREC:sender;
- copySomeView:theView;

- initFrame:(const NXRect *)frameRect;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end RECView.h */

