/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*             definition of REC operators and predicates                  */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

int rec(z) char *z; {if (rec_c(z,rprg,PLEN,dtbl)==1) rec_x(rprg);}

int rprze() {return(options[0]==TRUE);}
int rpron() {return(options[1]==TRUE);}
int rprtw() {return(options[2]==TRUE);}
int rprth() {return(options[3]==TRUE);}

void ropla() {alpha=(r_dblpar*PI)/180.0;}		/* set alpha     */

void roplc() {						/* draw circle   */
int c;
				PSstroke();
	c = *r_pc++;
	switch (c) {
	  case 'r': PSsetrgbcolor(1.0,0.0,0.0); break;
	  case 'g': PSsetrgbcolor(0.0,1.0,0.0); break;
	  case 'b': PSsetrgbcolor(0.0,0.0,1.0); break;
	  case 'k': PSsetgray(NX_BLACK); break;
	  case 'c': PSsetcmykcolor(1.0,0.0,0.0,0.0); break;
	  case 'm': PSsetcmykcolor(0.0,1.0,0.0,0.0); break;
	  case 'y': PSsetcmykcolor(0.0,0.0,1.0,0.0); break;
default:  PSsetgray(NX_BLACK); break;}
				PSmoveto(eks+5.0,wye);
				PSarc(eks, wye, 5.0, 0.0, 360.0);
				PSmoveto(eks,wye);
				PSstroke();
				PSsetgray(NX_BLACK);
}

void roplf() {scale*=sfac;}				/* shorten step    */

void roplh() {scale*=0.5;}				/* halve step      */

void roplj() {angle+=(r_dblpar*PI)/180.0;}		/* jog angle       */

void ropll() {angle+=afac*alpha;}			/* turn leftward   */

void roplm() {						/* take step       */
	eks+=scale*high*cos(angle);
	wye+=scale*high*sin(angle);
	PSlineto(eks,wye); 
}

void ropln() {double dx, dy, r, t;			/* finish segment  */
	dx=0.0-eks;
	dy=high/2.2-wye;
	r=sqrt(dx*dx+dy*dy)/high;
	t=atan2(dy,dx)*(180.0/PI);
	sprintf(errm,"$%6.2f$S $%6.2f$j m",r,t);
	isErrm=TRUE;
}

void roplo() {						/* set origin     */
	eks=0.0;
	wye=-high/2.2;
	scale=0.33;
	angle=PI/2.0,
	alpha=PI/8.0;
	plev=-1;
	PSmoveto(eks,wye);
}

void roplp() {						/* push figure data */
	plev++;
	if (plev>=FLEN) return;
	figr[plev][0]=eks;
	figr[plev][1]=wye;
	figr[plev][2]=angle;
	figr[plev][3]=alpha;
	figr[plev][4]=scale;
}

void roplr() {angle-=afac*alpha;}			/* turn rightward */

void ropls() {scale*=r_dblpar;}				/* change scale   */



void ropua() {angle=(r_dblpar*PI)/180.0;}		/* set angle   */

void ropuc() {						/* draw circle */
		PSsetgray(NX_BLACK);
		PSmoveto(eks+4.0,wye);
		PSarc(eks, wye, 4.0, 0.0, 360.0);
		PSmoveto(eks,wye);
}

void ropuf() {scale/=sfac;}				/* lengthen step     */

void ropuh() {scale*=2.0;}				/* double step       */

void ropuk() {angle+=PI/3.0;}				/* turn left 60 deg. */

void ropul() {angle+=PI/2.0;}				/* turn left         */

void ropum() {						/* take step         */
	eks+=scale*high*sin(angle);
	wye-=scale*high*cos(angle);
	PSmoveto(eks,wye); 
}

void ropun() {double dx, dy, r, t;			/* finish the loop  */
	dx=eks-0.0;
	dy=wye+high/2.2;
	r=sqrt(dx*dx+dy*dy)/high;
	t=atan2(dx,dy)*(180.0/PI);
	sprintf(errm,"$%6.2f$S $%6.2f$A m",r,t);
	isErrm=TRUE;
}

void ropuo() {						/* read figure data */
	if (plev<0) return;
	eks=figr[plev][0];
	wye=figr[plev][1];
	angle=figr[plev][2];
	alpha=figr[plev][3];
	scale=figr[plev][4];
	PSmoveto(eks,wye);
}

void ropup() {						/* pop figure data */
	if (plev<0) return;
	ropuo();
	plev--;
}

int  rpruq() {return(scale*high<5.0);}		/* test for minimum scale */

void ropur() {angle-=PI/2.0;}				/* turn right        */

void ropus() {scale=r_dblpar;}				/* set scale         */

void roput() {angle-=PI/3.0;}				/* turn 60 deg right */

/* ------------ */

void ropqm() {						/* print reg values */
  printf("scale %6.3f,plev %3d\n",scale,plev);
}

int rprns() {return (int)(random()&01);}		/* random 1/2 pred */

int rprps() {return random()%10==1;}			/* random 1/10 pred */

